/******************************************************************************\
|*                                                                            *|
|*                        Neurotechnologija Images 2.0                        *|
|*                                                                            *|
|* NImageFormat.h                                                             *|
|* Header file for NImageFormat module                                        *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef N_IMAGE_FORMAT_H_INCLUDED
#define N_IMAGE_FORMAT_H_INCLUDED

#include <NTypes.h>

#ifdef N_CPP
extern "C"
{
#endif

N_DECLARE_HANDLE(HNImageFormat)

#ifdef N_CPP
}
#endif

#include "NImage.h"

#ifdef N_CPP
extern "C"
{
#endif

NResult N_API NImageFormatGetFormatCount(NInt * pValue);
NResult N_API NImageFormatGetFormat(NInt index, HNImageFormat * pValue);

NResult N_API NImageFormatSelect(const NChar * szFileName, NFileAccess fileAccess, HNImageFormat * pHImageFormat);

NResult N_API NImageFormatGetBmp(HNImageFormat * pValue);
NResult N_API NImageFormatGetTiff(HNImageFormat * pValue);

NResult N_API NImageFormatLoadImageFromFile(HNImageFormat hImageFormat, const NChar * szFileName, HNImage * pHImage);
NResult N_API NImageFormatLoadImageFromMemory(HNImageFormat hImageFormat, void * buffer, NSizeType bufferLength, HNImage * pHImage);
NResult N_API NImageFormatSaveImageToFile(HNImageFormat hImageFormat, HNImage hImage, const NChar * szFileName);
NResult N_API NImageFormatSaveImageToMemory(HNImageFormat hImageFormat, HNImage hImage, void * * pBuffer, NSizeType * pBufferLength);

NResult N_API NImageFormatGetName(HNImageFormat hImageFormat, NChar * pValue);
NResult N_API NImageFormatGetDefaultFileExtension(HNImageFormat hImageFormat, NChar * pValue);
NResult N_API NImageFormatGetFileFilter(HNImageFormat hImageFormat, NChar * pValue);
NResult N_API NImageFormatCanRead(HNImageFormat hImageFormat, NBool * pValue);
NResult N_API NImageFormatCanWrite(HNImageFormat hImageFormat, NBool * pValue);

#ifdef N_CPP
}
#endif

#endif // !N_IMAGE_FORMAT_H_INCLUDED
