/******************************************************************************\
|*                                                                            *|
|*                         Neurotechnologija Core 2.0                         *|
|*                                                                            *|
|* NParameters.h                                                              *|
|* Header file for NParameters module                                         *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef N_PARAMETERS_H_INCLUDED
#define N_PARAMETERS_H_INCLUDED

#include "NCore.h"

#ifdef N_CPP
extern "C"
{
#endif

// Type ids

#define N_TYPE_BYTE      1
#define N_TYPE_SBYTE     2
#define N_TYPE_USHORT    3
#define N_TYPE_SHORT     4
#define N_TYPE_UINT      5
#define N_TYPE_INT       6
#ifndef N_N_INT_64
#define N_TYPE_ULONG     7
#define N_TYPE_LONG      8
#endif
#define N_TYPE_BOOL     10
#define N_TYPE_CHAR     20
#ifndef N_NO_FLOAT
#define N_TYPE_FLOAT    30
#define N_TYPE_DOUBLE   31
#endif
#define N_TYPE_STRING  100

// Parameter id codes

#define N_PC_TYPE_ID 1

#define NParameterMakeId(code, index, id) ((NUInt)(((code) << 24) | (((index) & 0xFF) << 16) | ((id) & 0xFFFF)))

#ifdef N_CPP
}
#endif

#endif // !N_PARAMETERS_H_INCLUDED
