/******************************************************************************\
|*                                                                            *|
|*          Neurotechnologija Fingerprint Features Extractor VF 1.0           *|
|*                                                                            *|
|* VFExtractorParams.h                                                        *|
|* VFExtractor parameters definition                                          *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef VF_EXTRACTOR_PARAMS_H_INCLUDED
#define VF_EXTRACTOR_PARAMS_H_INCLUDED

#include "NParameters.h"
#include "VFExtractorTypes.h"

#ifdef N_CPP
extern "C"
{
#endif

// Main parameters

#define VFEP_NAME         10 // Static, Readonly, String | Returns name of the library
#define VFEP_VERSION_HIGH 11 // Static, Readonly, UInt   | Returns high part of the library version
#define VFEP_VERSION_LOW  12 // Static, Readonly, UInt   | Returns low part of the library version
#define VFEP_COPYRIGHT    13 // Static, Readonly, String | Returns copyright of the library

#define VFEP_TEMPLATE_SIZE  100 // Int | Can be one of VfeTemplateSize values
#define VFEP_RETURNED_IMAGE 190 // Int | Can be one of VfeReturnedImage values

#define VFEP_USE_QUALITY       900 // Bool
#define VFEP_QUALITY_THRESHOLD 910 // Byte

#define VFEP_GENERALIZATION_THRESHOLD          300 // Int | >= 0
#define VFEP_GENERALIZATION_MAXIMAL_ROTATION   301 // Byte | 0..128

#define VFEP_MODE 1000 // UInt | Can be one of the following
	#define VFE_MODE_GENERAL                           0
	#define VFE_MODE_DIGITALPERSONA_UAREU            100
	#define VFE_MODE_BIOMETRIKA_FX2000               200
	#define VFE_MODE_BIOMETRIKA_FX3000               201
	#define VFE_MODE_KEYTRONIC_SECUREDESKTOP         300
	#define VFE_MODE_IDENTIX_TOUCHVIEW               400
	#define VFE_MODE_IDENTIX_DFR2090                 401
	#define VFE_MODE_PRECISEBIOMETRICS_100CS         500
	#define VFE_MODE_UPEK_TOUCHCHIP                  600
	#define VFE_MODE_IDENTICATORTECHNOLOGY_DF90      700
	#define VFE_MODE_AUTHENTEC_AFS2                  800
	#define VFE_MODE_AUTHENTEC_AES4000               810
	#define VFE_MODE_AUTHENTEC_AES2501B              811
	#define VFE_MODE_ATMEL_FINGERCHIP                900
	#define VFE_MODE_BMF_BLP100                     1000
	#define VFE_MODE_SECUGEN_HAMSTER                1100
	#define VFE_MODE_ETHENTICA                      1200
	#define VFE_MODE_CROSSMATCH_VERIFIER300         1300
	#define VFE_MODE_NITGEN_FINGKEY_HAMSTER         1400
	#define VFE_MODE_TESTECH_BIOI                   1500
	#define VFE_MODE_DIGENT_IZZIX                   1600
	#define VFE_MODE_STARTEK_FM200                  1700
	#define VFE_MODE_FUJITSU_MBF200                 1800
	#define VFE_MODE_FUTRONIC_FS80                  1900
	#define VFE_MODE_LIGHTUNING_LTTC500             2000
	#define VFE_MODE_TACOMA_CMOS                    2100

#ifdef N_CPP
}
#endif

#endif // !VF_EXTRACTOR_PARAMS_H_INCLUDED
