#include "System.h"
#include "GUIApplication.h"
#include "VFingerX.h"
#include "ScanManX.h"
#include "MainForm.h"

class CVFDemoApp: public CGUIApplication
{
public:
	CVFDemoApp(HINSTANCE handle, int cmd_show)
		: CGUIApplication(handle, cmd_show, true)
	{
		SetName(STRING("VeriFinger Demo for Visual C++"));
		SetVersion(MAKEDWORD(0, 5), MAKEDWORD(1, 0));
		SetCopyright(STRING("Copyright  1998-2006 Neurotechnologija"));
		SetCompany(STRING("Neurotechnologija"));
		SetRegistryKey(STRING("Software\\Neurotechnologija\\VeriFinger\\Demo"));
		VFCheckResult(VFInitialize());
		SMCheckResult(SMInitialize());
	}

	~CVFDemoApp()
	{
		SMFinalize();
		VFFinalize();
	}
};

// Program entry point
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPSTR /*lpCmdLine*/, int nCmdShow)
{
	try
	{
		CVFDemoApp app(hInstance, nCmdShow);
		try
		{
			return app.Run(new CMainForm(TEXT("VFDemo"), VF_ENGINE_NAME));
		}
		catch(exception &e)
		{
			ErrorBox(NULL, e);
			return FALSE;
		}
	}
	catch(exception &e)
	{
		::MessageBox(NULL, (LPCTSTR)AnsiToString(e.what()), (LPCTSTR)STRING("Error"), MB_OK | MB_ICONERROR);
		return FALSE;
	}
	catch(_com_error &e)
	{
		::MessageBox(NULL,
			(LPCTSTR)Format(TEXT("Code = %08lx\nCode meaning = %s\nSource = %s\nDescription = %s"),
				e.Error(), e.ErrorMessage(), (LPCTSTR)e.Source(), (LPCTSTR)e.Description()),
			(LPCTSTR)STRING("COM Error"), MB_OK | MB_ICONERROR);
		return FALSE;
	}
}
