#pragma once

#pragma warning(disable: 4786)

#include "msxml3.tlh"

#define XmlGetAttributeValue(attributes, value, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(#value);\
	if((bool)attribute) value = function(attribute->text);\
}

#define XmlGetAttributeValueN(attributes, value, name, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(name);\
	if((bool)attribute) value = function(attribute->text);\
}

#define XmlGetAttributeValueD(attributes, value, defaultValue, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(#value);\
	value = (bool)attribute ? function(attribute->text) : defaultValue;\
}

#define XmlGetAttributeValueDN(attributes, value, defaultValue, name, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(name);\
	value = (bool)attribute ? function(attribute->text) : defaultValue;\
}

#define XmlSetAttributeValue(document, attributes, value, function) \
{\
	MSXML2::IXMLDOMAttributePtr attribute = document->createAttribute(#value);\
	attribute->text = function(value);\
	attributes->setNamedItem(attribute);\
}

#define XmlSetAttributeValueN(document, attributes, value, name, function) \
{\
	MSXML2::IXMLDOMAttributePtr attribute = document->createAttribute(name);\
	attribute->text = function(value);\
	attributes->setNamedItem(attribute);\
}

#define XmlGetAttributeMemberValue(attributes, value, name, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(#name);\
	if((bool)attribute) value.##name = function(attribute->text);\
}

#define XmlGetAttributeMemberValueD(attributes, value, defaultValue, name, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(#name);\
	value.##name = (bool)attribute ? function(attribute->text) : defaultValue;\
}

#define XmlGetAttributeMemberValueDM(attributes, value, defaultValue, name, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(#name);\
	value.##name = (bool)attribute ? function(attribute->text) : defaultValue.##name;\
}

#define XmlSetAttributeMemberValue(document, attributes, value, name, function) \
{\
	MSXML2::IXMLDOMAttributePtr attribute = document->createAttribute(#name);\
	attribute->text = function(value.##name);\
	attributes->setNamedItem(attribute);\
}

#define XmlGetAttributeMemberPValue(attributes, value, name, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(#name);\
	if((bool)attribute) value->##name = function(attribute->text);\
}

#define XmlGetAttributeMemberPValueD(attributes, value, defaultValue, name, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(#name);\
	value->##name = (bool)attribute ? function(attribute->text) : defaultValue;\
}

#define XmlGetAttributeMemberPValueDM(attributes, value, defaultValue, name, function) \
{\
	MSXML2::IXMLDOMNodePtr attribute = attributes->getNamedItem(#name);\
	value->##name = (bool)attribute ? function(attribute->text) : defaultValue->##name;\
}

#define XmlSetAttributeMemberPValue(document, attributes, value, name, function) \
{\
	MSXML2::IXMLDOMAttributePtr attribute = document->createAttribute(#name);\
	attribute->text = function(value->##name);\
	attributes->setNamedItem(attribute);\
}

inline MSXML2::IXMLDOMDocumentPtr XmlCreateDocument()
{
	MSXML2::IXMLDOMDocumentPtr document;
	TESTHR(document.CreateInstance(TEXT("Msxml2.DOMDocument.3.0")));
	return document;
}
