/* $Id: list.c 9003 2006-09-15 11:45:29Z grazvydas $ */
#include <stdlib.h>
#include <string.h>

struct list {
	struct list *next;
	char *name;
	int size;
	void *data;
};

static struct list *root[256] = { NULL, };
static struct list *iter = NULL;
static unsigned char iter_g = 0;
static unsigned char iter_pos = 0;
static int db_size = 0;

int list_size ()
{
	return db_size;
}

void list_add (void *data, int size, const char *name, unsigned char g)
{
	struct list* item;

	item = (struct list *) malloc (sizeof (struct list));
	if (item == NULL)
		return;

	item -> data = malloc (size);
	if (item -> data == NULL)
		return;

	memcpy (item -> data, data, size);
	item -> name = strdup (name);

	item -> size = size;
	item -> next = root[g];
	root[g] = item;

	iter = NULL;

	db_size ++;
}

void list_get_start_g (unsigned char g)
{
	iter = root[g];
	iter_g = g;
	iter_pos = g;
}

void list_get_start ()
{
	iter = root[0];
	iter_pos = 0;
	iter_g = 0;
}

void *list_get_next_g (char **name, int *size)
{
	void *data;
	int i;

	while (iter == NULL)
	{
		if (iter_g < iter_pos)
			i = (int)iter_g - (int)iter_pos + (int)iter_g;
		else
			i = (int)iter_g - (int)iter_pos + (int)iter_g + 1;
		if (i < 0)
		{
			if (iter_pos == 255)
				return 0;
			else
				i = (int)iter_pos + 1;
		}

		if (i > 255)
		{
			if (iter_pos == 0)
				return NULL;
			else
				i = (int)iter_pos - 1;
		}

		iter_pos = i;
		iter = root[iter_pos];
	}

	if (name)
		*name = iter -> name;
	if (size)
		*size = iter -> size;

	data = iter -> data;
	iter = iter -> next;

	return data;
}

void *list_get_next (char **name, int *size)
{
	void *data;

	while (iter == NULL)
	{
		if (iter_pos == 255)
			return NULL;
		iter_pos++;
		iter = root[iter_pos];
	}

	if (name)
		*name = iter -> name;
	if (size)
		*size = iter -> size;

	data = iter -> data;
	iter = iter -> next;

	return data;
}

void list_clear ()
{
	static struct list *n, *t;
	int i;

	for (i = 0; i < 256; i++)
	{
		n = root[i];
		while (n)
		{
			t = n -> next;
			if (n -> name)
				free (n -> name);
			if (n -> data)
				free (n -> data);
			n = t;
		}
		root[i] = NULL;
	}
	iter = NULL;
	iter_g = 0;
	iter_pos = 0;
	db_size = 0;
}
