#include <stdio.h>
#include <time.h>
#include <string.h>
#include "fx3dll.h"

#ifdef FXDLL_LINUX
	#ifdef CLOCKS_PER_SEC
	#undef CLOCKS_PER_SEC
	#endif
	extern int CLOCKS_PER_SEC;
#endif //Linux


static clock_t time_start,time_end,time_elapsed;

void Outtime(char *task) {
	printf("Time for %s: %4.2f sec\n",task,(float)time_elapsed/CLOCKS_PER_SEC);
}

void Start_process() {
	time_elapsed=0;
	time_start=clock();
}

void End_process() {
	time_end=clock();
	time_elapsed+=time_end-time_start;
}

int cbFunc(int presence,int quality,unsigned char* image,unsigned short int ix,unsigned short int iy)
{ // A raw image (ix*iy pixels) is available in image ...
  printf("   Presence:%d   Quality:%d Dim:%dx%d\n",presence,quality,ix,iy);
	if ((presence>80)&&(quality>30))
		return 1;
	else
  		return 0;   
}

int main(int argc, char * argv[]) 
{
	FX3error err;
	float quality; 
	float similarity;
	unsigned char Led=1; 
	char fx3[16],fx3scan[16],fx3enrdlg[16];
	unsigned char LiveMode=2;
	unsigned char Presence;

	
	
	// Query sdk version
	FX3_Version(fx3,fx3scan,fx3enrdlg);
	printf("DLLs Version - fx3.dll: %s    fx3scan.dll: %s    fx3enrdlg.dll: %s\n",fx3,fx3scan,fx3enrdlg); 
	
	// Initialization
	err=FX3_Init();
	if (err) { printf("\nInit Error: %d\n",err); return 1; }
	else printf("\nInitialization OK\n");
	

	// For FX2000-compliant FX3SDK use autodetection ...
	if (strcmp(fx3+strlen(fx3)-2,"FX")==0)
	{ // Auto Detection Mode 
		err=FX3_FX_EnterAutoDetection();
		if (err) { printf("\nFX Enter AutoDetection Error: %d\n",err); FX3_End(); return 1; }
		else printf("\nPut the finger on the sensor ...");
		// Loop until the user touch the sensor, then uses AGI 
		do 
		{ 
			err=FX3_FX_Presence(&Presence);
			if (err)
			{ 
				printf("\nFX AutoDetection Error: %d\n",err);
				FX3_FX_ExitAutoDetection();  
				FX3_End();
				return 1;
			}
			Sleep(200);
		}
		while (Presence < 10);
		
		err=FX3_FX_ExitAutoDetection();
		if (err) { printf("\nFX Exit AutoDetection Error: %d\n",err); FX3_End(); return 1; }
		
		  err=FX3_FX_SetConfig(&LiveMode,NULL,NULL,NULL);
		  if (err) { printf("\nFingerprint scanner setting Error: %d\n",err); FX3_End(); return 1; }
	}

	// Get current fingerprint
#ifdef MUTE
	err=FX3_MuteAcquireFingerprintOnLine(&quality,80,15,0.5); 
#else
	err=FX3_AcquireFingerprintOnLine(NULL,-1,-1,&quality,80,15,0.5); 
#endif
	if (err) { printf("\nFingerprint Acquisition Error: %d\n",err); FX3_End(); return 1; }
	else printf("\nFingerprint Acquired, quality: %4.3f\n",quality);

	// Get a second fingerprint
	printf("MUTE AcquireFingerprintOnLine\n");
   // Using on-line mute acquisition (callback mode)
	err=FX3_CallBackAcquireFingerprintOnLine(&quality,80,20,0.2F,cbFunc);
   if (err) { printf("\nFingerprint 2 Acquisition Error: %d\n",err); FX3_End(); return 1; }
   else printf("\nFingerprint 2 Acquired, quality: %4.3f\n",quality);

	// Terminating
	err=FX3_End();
	if (err) { printf("\nExit Error: %d\n",err); return 1; }
	
	return 0;
}
