/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include <stdio.h>
#include <time.h>
#include <string.h>
#include "fx3dll.h"

#ifdef CLOCKS_PER_SEC
#undef CLOCKS_PER_SEC
#endif
extern int CLOCKS_PER_SEC;


static clock_t time_start, time_end, time_elapsed;

void Outtime (char *task)
{
	printf ("Time for %s: %4.2f sec\n", task, (float) time_elapsed / CLOCKS_PER_SEC);
}

void Start_process ()
{
	time_elapsed = 0;
	time_start = clock ();
}

void End_process ()
{
	time_end = clock ();
	time_elapsed += time_end - time_start;
}


int main (int argc, char *argv[])
{
	FX3error err;
	float quality;
	float similarity;
	unsigned char Led = 1;
	char fx3[16], fx3scan[16], fx3enrdlg[16];
	unsigned char LiveMode = 2;
	unsigned char Presence;



	gtk_set_locale ();
	gtk_init (&argc, &argv);



	// Query sdk version
	FX3_Version (fx3, fx3scan, fx3enrdlg);
	printf ("Lib Version - fx3: %s    fx3scan: %s    fx3enrdlg: %s\n", fx3, fx3scan, fx3enrdlg);

	// Initialization
	err = FX3_Init ();
	if (err)
	{
		printf ("\nInit Error: %d\n", err);
		return 1;
	}
	else
		printf ("\nInitialization OK\n");


	// For FX2000-compliant FX3SDK use autodetection ...
	if (strcmp (fx3 + strlen (fx3) - 2, "FX") == 0)
	{		// Auto Detection Mode 
		err = FX3_FX_EnterAutoDetection ();
		if (err)
		{
			printf ("\nFX Enter AutoDetection Error: %d\n", err);
			FX3_End ();
			return 1;
		}
		else
			printf ("\nPut the finger on the sensor ...");
		// Loop until the user touch the sensor, then uses AGI 
		do
		{
			err = FX3_FX_Presence (&Presence);
			if (err)
			{
				printf ("\nFX AutoDetection Error: %d\n", err);
				FX3_FX_ExitAutoDetection ();
				FX3_End ();
				return 1;
			}
			Sleep (200);
		}
		while (Presence < 10);
		err = FX3_FX_ExitAutoDetection ();
		if (err)
		{
			printf ("\nFX Exit AutoDetection Error: %d\n", err);
			FX3_End ();
			return 1;
		}

		err = FX3_FX_SetConfig (&LiveMode, NULL, NULL, NULL);
		if (err)
		{
			printf ("\nFingerprint scanner setting Error: %d\n", err);
			FX3_End ();
			return 1;
		}
	}

	// Get current fingerprint
	//err = FX3_MuteAcquireFingerprintOnLine (&quality, 80, 15, 0.5);
	err = FX3_AcquireFingerprintOnLine (NULL, -1, -1, &quality, 80, 15, 0.5);
	if (err)
	{
		printf ("\nFingerprint Acquisition Error: %d\n", err);
		FX3_End ();
		return 1;
	}
	else
		printf ("\nFingerprint Acquired, quality: %4.3f\n", quality);

	// Terminating
	err = FX3_End ();
	if (err)
	{
		printf ("\nExit Error: %d\n", err);
		return 1;
	}

	return 0;
}
